import React, { useRef } from "react";
import Taro from "@tarojs/taro";
import { View, Image } from "@tarojs/components";
import { useModel } from "@/store";
import { Loading, Notify, Dialog } from "@antmjs/vantui";
import NavLoading from "@/components/NavLoading";
import Auth from "@/components/Auth";
import TabBar from "./TabBar";
import laySty from "./layout.module.less";
import { useEffect } from "react";

export default (props) => {
  const { className, style, roles, tabBar = false, loading } = props;

  const { person, user, duty, current } = useModel('user');

  const containerClass = `${laySty["page-conatiner"]} ${
    tabBar ? laySty["with-tabbar"] : ""
  } ${className}`;
  React.useEffect(() => {
    const currentPage = Taro.getCurrentPages().slice().pop();

    if (!user) {
      try {
        current().then((res) => {
          console.log('---当前人员----', res);
        }).catch((err) => {
          console.log('---当前人员--报错了--');
          console.error(err);
  
          if (!currentPage.route.includes("pages/login/index")) {
            Taro.navigateTo({
              url: "/pages/login/index",
            });
          }
        });
      } catch (error) {
        console.error(error);
      }
    }

    // if (!person || !user) {
    //   if (!currentPage.route.includes("pages/login/index")) {
    //     Taro.navigateTo({
    //       url: "/pages/login/index",
    //     });

    //     return;
    //   }
    // }
  }, [current, user]);


  // React.useEffect(() => {
  //   console.log("personRef******************");
  //   // console.log(person);
  //   console.log("userRef******************");
  //   console.log(user);
  //   console.log(!user);
  //   // if (!userRef.current&&user) {
  //   //   userRef.current = user;
  //   // }

  //   if (!user) {
  //     currentUser().catch(() => {
  //       const currentPage = Taro.getCurrentPages().slice().pop();
  //       if (!currentPage.route.includes("pages/login/index")) {
  //         Taro.navigateTo({
  //           url: "/pages/login/index",
  //         });
  //       }
  //     });
  //   }
  // }, [user]);

  Taro.useShareAppMessage(() => {
    return {
      title: "文明城市",
    };
  });

  useEffect(() => {
      // 获取当前编码后的标题
      var encodedTitle = document.title;
      // 解码标题
      var decodedTitle = decodeURIComponent(encodedTitle);
      // 设置解码后的标题
      document.title = decodedTitle;
  }, []);

  return (
    <View className={laySty["page-wrapper"]}>
      <Notify id="vanNotify" />
      <Dialog id="vanDialog" />
      <NavLoading loading={loading} />
      <View className={containerClass} style={style}>
        {/* {!user && (
          <View className={laySty.loading}>
            <Loading size="32px" vertical>
              加载中...
            </Loading>
          </View>
        )} */}
        <Auth roles={roles}>{props.children}</Auth>

        {!tabBar && <View className={laySty["pdm-space"]}></View>}
      </View>
      {tabBar && (
        <TabBar className={laySty["page-tabbar"]} active={tabBar} duty={duty} />
      )}
    </View>
  );
};
