import Taro from "@tarojs/taro";
import { promise } from "./promise";
import { translate } from "./map";

export default function getAuthorize(scope) {
  return new Promise((resolve, reject) => {
    Taro.getSetting({
      success(res) {
        if (!res.authSetting[scope]) {
          Taro.authorize({
            scope,
            success: resolve,
            fail: (err) => {
              console.error(err);
              reject(err);
            },
          });
        } else {
          resolve();
        }
      },
      fail(err) {
        console.error(err);
        reject(err);
      },
    });
  });
}

export const getLocation = () => {
  // eslint-disable-next-line no-undef
  if (!IS_APP_CLIENT) {

    // eslint-disable-next-line no-undef
    const parts = DEFAULT_POS.split(',');
    const defaultPost = {
      location: {
        lat: parts[1],
        lng: parts[0],
      },
    }

    return promise((resolve, reject) => {
      // eslint-disable-next-line no-undef
      new TMap.service.IPLocation().locate().then(res => {
        if (res.status == 0) {
          resolve(res.result);
        } else {
          console.error("-----定位失败----")
          console.error(res.message)
          resolve(defaultPost);
        }
      }).catch(e => {
        console.error("-----定位失败----")
        console.error(e)
        resolve(defaultPost);
      });
    });
    
  }

  return promise((resolve, reject) => {
    // eslint-disable-next-line no-undef
    SmartCity.getLocation(function(res){
      // 百度坐标
      // {
      //   "longitude": "经度 ",
      //   "latitude": "纬度",
      //   "provinces": "省",
      //   "city": "市",
      //   "area": "区",
      //   "address": "地址",
      //   "parameter": "传给客户端的参数",
      // }
      console.log('定位地址:' , res);

      translate(res.latitude, res.longitude).then(res2 => {
        resolve({ ...res, location: res2 });
      }).catch(reject);
    });
  });
};

// export const h5GetLocation = () => {
  // return new TMap.service.IPLocation().locate();

  // return new Promise((resolve, reject) => {
  //   const url = `${MAPHOST}/ws/location/v1/ip?key=${key}`;
  //   const res = Taro.request({
  //     url: url,
  //     method: "GET",
  //     dataType: "json",
  //     header: {
  //       "content-type": "application/json",
  //     },
  //   });
  //   resolve(res);
  //   reject(res);
  //   // .then((res) => {
  //   //   resolve(res.result);
  //   // })
  //   // .catch((error) => {
  //   //   reject(error);
  //   //   console.error("请求失败", error);
  //   // });
  // });
// };
